/* GradeLabel.c generated by valac 0.43.6, the Vala compiler
 * generated from GradeLabel.vala, do not modify */

/*
* Copyright (c) 2017 Daniel Foré (http://danielfore.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define TYPE_GRADE_LABEL (grade_label_get_type ())
#define GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRADE_LABEL, GradeLabel))
#define GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRADE_LABEL, GradeLabelClass))
#define IS_GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRADE_LABEL))
#define IS_GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRADE_LABEL))
#define GRADE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRADE_LABEL, GradeLabelClass))

typedef struct _GradeLabel GradeLabel;
typedef struct _GradeLabelClass GradeLabelClass;
typedef struct _GradeLabelPrivate GradeLabelPrivate;
enum  {
	GRADE_LABEL_0_PROPERTY,
	GRADE_LABEL_LEVEL_PROPERTY,
	GRADE_LABEL_PASS_PROPERTY,
	GRADE_LABEL_NUM_PROPERTIES
};
static GParamSpec* grade_label_properties[GRADE_LABEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GradeLabel {
	GtkGrid parent_instance;
	GradeLabelPrivate * priv;
};

struct _GradeLabelClass {
	GtkGridClass parent_class;
};

struct _GradeLabelPrivate {
	GtkImage* icon;
	gchar* _level;
};

static gint GradeLabel_private_offset;
static gpointer grade_label_parent_class = NULL;

GType grade_label_get_type (void) G_GNUC_CONST;
GradeLabel* grade_label_new (const gchar* level);
GradeLabel* grade_label_construct (GType object_type,
                                   const gchar* level);
const gchar* grade_label_get_level (GradeLabel* self);
static void grade_label_set_level (GradeLabel* self,
                            const gchar* value);
void grade_label_set_pass (GradeLabel* self,
                           gboolean value);
static GObject * grade_label_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void grade_label_finalize (GObject * obj);
static void _vala_grade_label_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_grade_label_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
grade_label_get_instance_private (GradeLabel* self)
{
	return G_STRUCT_MEMBER_P (self, GradeLabel_private_offset);
}

GradeLabel*
grade_label_construct (GType object_type,
                       const gchar* level)
{
	GradeLabel * self = NULL;
#line 34 "../src/GradeLabel.vala"
	g_return_val_if_fail (level != NULL, NULL);
#line 35 "../src/GradeLabel.vala"
	self = (GradeLabel*) g_object_new (object_type, "height-request", 76, "width-request", 76, "level", level, "margin", 12, "margin-bottom", 24, NULL);
#line 34 "../src/GradeLabel.vala"
	return self;
#line 106 "GradeLabel.c"
}

GradeLabel*
grade_label_new (const gchar* level)
{
#line 34 "../src/GradeLabel.vala"
	return grade_label_construct (TYPE_GRADE_LABEL, level);
#line 114 "GradeLabel.c"
}

const gchar*
grade_label_get_level (GradeLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/GradeLabel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/GradeLabel.vala"
	_tmp0_ = self->priv->_level;
#line 23 "../src/GradeLabel.vala"
	result = _tmp0_;
#line 23 "../src/GradeLabel.vala"
	return result;
#line 130 "GradeLabel.c"
}

static void
grade_label_set_level (GradeLabel* self,
                       const gchar* value)
{
#line 23 "../src/GradeLabel.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/GradeLabel.vala"
	if (g_strcmp0 (value, grade_label_get_level (self)) != 0) {
#line 141 "GradeLabel.c"
		gchar* _tmp0_;
#line 23 "../src/GradeLabel.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/GradeLabel.vala"
		_g_free0 (self->priv->_level);
#line 23 "../src/GradeLabel.vala"
		self->priv->_level = _tmp0_;
#line 23 "../src/GradeLabel.vala"
		g_object_notify_by_pspec ((GObject *) self, grade_label_properties[GRADE_LABEL_LEVEL_PROPERTY]);
#line 151 "GradeLabel.c"
	}
}

void
grade_label_set_pass (GradeLabel* self,
                      gboolean value)
{
#line 25 "../src/GradeLabel.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/GradeLabel.vala"
	if (value) {
#line 163 "GradeLabel.c"
		GtkImage* _tmp0_;
#line 27 "../src/GradeLabel.vala"
		_tmp0_ = self->priv->icon;
#line 27 "../src/GradeLabel.vala"
		g_object_set (_tmp0_, "icon-name", "object-select-symbolic", NULL);
#line 169 "GradeLabel.c"
	} else {
		GtkImage* _tmp1_;
#line 29 "../src/GradeLabel.vala"
		_tmp1_ = self->priv->icon;
#line 29 "../src/GradeLabel.vala"
		g_object_set (_tmp1_, "icon-name", "window-close-symbolic", NULL);
#line 176 "GradeLabel.c"
	}
#line 25 "../src/GradeLabel.vala"
	g_object_notify_by_pspec ((GObject *) self, grade_label_properties[GRADE_LABEL_PASS_PROPERTY]);
#line 180 "GradeLabel.c"
}

static GObject *
grade_label_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GradeLabel * self;
	GtkLabel* level = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkLabel* _tmp12_;
	GtkImage* _tmp13_;
#line 44 "../src/GradeLabel.vala"
	parent_class = G_OBJECT_CLASS (grade_label_parent_class);
#line 44 "../src/GradeLabel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../src/GradeLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GRADE_LABEL, GradeLabel);
#line 45 "../src/GradeLabel.vala"
	_tmp0_ = self->priv->_level;
#line 45 "../src/GradeLabel.vala"
	_tmp1_ = g_strdup_printf ("<small><b>%s</b></small>", _tmp0_);
#line 45 "../src/GradeLabel.vala"
	_tmp2_ = _tmp1_;
#line 45 "../src/GradeLabel.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
#line 45 "../src/GradeLabel.vala"
	g_object_ref_sink (_tmp3_);
#line 45 "../src/GradeLabel.vala"
	_tmp4_ = _tmp3_;
#line 45 "../src/GradeLabel.vala"
	_g_free0 (_tmp2_);
#line 45 "../src/GradeLabel.vala"
	level = _tmp4_;
#line 46 "../src/GradeLabel.vala"
	_tmp5_ = level;
#line 46 "../src/GradeLabel.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp5_, 20);
#line 47 "../src/GradeLabel.vala"
	_tmp6_ = level;
#line 47 "../src/GradeLabel.vala"
	g_object_set ((GtkWidget*) _tmp6_, "width-request", 76, NULL);
#line 48 "../src/GradeLabel.vala"
	_tmp7_ = level;
#line 48 "../src/GradeLabel.vala"
	gtk_label_set_use_markup (_tmp7_, TRUE);
#line 50 "../src/GradeLabel.vala"
	_tmp8_ = (GtkImage*) gtk_image_new ();
#line 50 "../src/GradeLabel.vala"
	g_object_ref_sink (_tmp8_);
#line 50 "../src/GradeLabel.vala"
	_g_object_unref0 (self->priv->icon);
#line 50 "../src/GradeLabel.vala"
	self->priv->icon = _tmp8_;
#line 51 "../src/GradeLabel.vala"
	_tmp9_ = self->priv->icon;
#line 51 "../src/GradeLabel.vala"
	g_object_set (_tmp9_, "icon-size", (gint) GTK_ICON_SIZE_LARGE_TOOLBAR, NULL);
#line 52 "../src/GradeLabel.vala"
	_tmp10_ = self->priv->icon;
#line 52 "../src/GradeLabel.vala"
	g_object_set (_tmp10_, "icon-name", "object-select-symbolic", NULL);
#line 54 "../src/GradeLabel.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 55 "../src/GradeLabel.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 55 "../src/GradeLabel.vala"
	gtk_style_context_add_class (_tmp11_, "grade");
#line 56 "../src/GradeLabel.vala"
	_tmp12_ = level;
#line 56 "../src/GradeLabel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
#line 57 "../src/GradeLabel.vala"
	_tmp13_ = self->priv->icon;
#line 57 "../src/GradeLabel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
#line 44 "../src/GradeLabel.vala"
	_g_object_unref0 (level);
#line 44 "../src/GradeLabel.vala"
	return obj;
#line 274 "GradeLabel.c"
}

static void
grade_label_class_init (GradeLabelClass * klass,
                        gpointer klass_data)
{
#line 20 "../src/GradeLabel.vala"
	grade_label_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/GradeLabel.vala"
	g_type_class_adjust_private_offset (klass, &GradeLabel_private_offset);
#line 20 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_grade_label_get_property;
#line 20 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_grade_label_set_property;
#line 20 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (klass)->constructor = grade_label_constructor;
#line 20 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (klass)->finalize = grade_label_finalize;
#line 20 "../src/GradeLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRADE_LABEL_LEVEL_PROPERTY, grade_label_properties[GRADE_LABEL_LEVEL_PROPERTY] = g_param_spec_string ("level", "level", "level", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/GradeLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRADE_LABEL_PASS_PROPERTY, grade_label_properties[GRADE_LABEL_PASS_PROPERTY] = g_param_spec_boolean ("pass", "pass", "pass", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 297 "GradeLabel.c"
}

static void
grade_label_instance_init (GradeLabel * self,
                           gpointer klass)
{
#line 20 "../src/GradeLabel.vala"
	self->priv = grade_label_get_instance_private (self);
#line 306 "GradeLabel.c"
}

static void
grade_label_finalize (GObject * obj)
{
	GradeLabel * self;
#line 20 "../src/GradeLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GRADE_LABEL, GradeLabel);
#line 21 "../src/GradeLabel.vala"
	_g_object_unref0 (self->priv->icon);
#line 23 "../src/GradeLabel.vala"
	_g_free0 (self->priv->_level);
#line 20 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (grade_label_parent_class)->finalize (obj);
#line 321 "GradeLabel.c"
}

GType
grade_label_get_type (void)
{
	static volatile gsize grade_label_type_id__volatile = 0;
	if (g_once_init_enter (&grade_label_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GradeLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) grade_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GradeLabel), 0, (GInstanceInitFunc) grade_label_instance_init, NULL };
		GType grade_label_type_id;
		grade_label_type_id = g_type_register_static (gtk_grid_get_type (), "GradeLabel", &g_define_type_info, 0);
		GradeLabel_private_offset = g_type_add_instance_private (grade_label_type_id, sizeof (GradeLabelPrivate));
		g_once_init_leave (&grade_label_type_id__volatile, grade_label_type_id);
	}
	return grade_label_type_id__volatile;
}

static void
_vala_grade_label_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	GradeLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GRADE_LABEL, GradeLabel);
#line 20 "../src/GradeLabel.vala"
	switch (property_id) {
#line 20 "../src/GradeLabel.vala"
		case GRADE_LABEL_LEVEL_PROPERTY:
#line 20 "../src/GradeLabel.vala"
		g_value_set_string (value, grade_label_get_level (self));
#line 20 "../src/GradeLabel.vala"
		break;
#line 354 "GradeLabel.c"
		default:
#line 20 "../src/GradeLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/GradeLabel.vala"
		break;
#line 360 "GradeLabel.c"
	}
}

static void
_vala_grade_label_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	GradeLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GRADE_LABEL, GradeLabel);
#line 20 "../src/GradeLabel.vala"
	switch (property_id) {
#line 20 "../src/GradeLabel.vala"
		case GRADE_LABEL_LEVEL_PROPERTY:
#line 20 "../src/GradeLabel.vala"
		grade_label_set_level (self, g_value_get_string (value));
#line 20 "../src/GradeLabel.vala"
		break;
#line 20 "../src/GradeLabel.vala"
		case GRADE_LABEL_PASS_PROPERTY:
#line 20 "../src/GradeLabel.vala"
		grade_label_set_pass (self, g_value_get_boolean (value));
#line 20 "../src/GradeLabel.vala"
		break;
#line 386 "GradeLabel.c"
		default:
#line 20 "../src/GradeLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/GradeLabel.vala"
		break;
#line 392 "GradeLabel.c"
	}
}

